/*************************************************
		GlcdPlus.h
		Ver. 0.95

	Copyright (C) 2010-2011,
		MicroFan, Div. PeopleMedia, Inc.
	All rights reserved.
*************************************************/


#ifndef GlcdPlus_h
#define GlcdPlus_h

#include <inttypes.h>
#include "Print.h"

#define  IODIRA  0x00
#define  IODIRB  0x01
#define  IOCON  0x0A
#define  GPPUA  0x0C
#define  GPPUB  0x0D
#define  GPIOA  0x12
#define  GPIOB  0x13
#define  OLATA  0x14
#define  OLATB  0x15

#define GPIO_READ   0x41
#define GPIO_WRITE  0x40

class SpiGpio {
public:
    SpiGpio(uint8_t, uint8_t) ;
    void write(uint8_t, uint8_t) ;
    uint8_t read(uint8_t) ;
private:
    uint8_t pinSS ;
    uint8_t devAddr ;
    uint8_t access_addr8(uint8_t, uint8_t, uint8_t) ;
} ;


#define	GLCD_X_MAX	128
#define	GLCD_Y_MAX	64

#define	GLCD_SELECT_ALL		3
#define	GLCD_SELECT_LEFT	1
#define	GLCD_SELECT_RIGHT	2

#define	GLCD_DISPLAY_ON		0b00111111
#define	GLCD_DISPLAY_OFF	0b00111110

#define	GLCD_SET_ADDRESS		0b01000000
#define	GLCD_PAGE_ADDRESS_SET	0b10111000
#define	GLCD_DISPLAY_START_LINE	0b11000000

#define	GLCD_PIXEL_CLEAR	0
#define	GLCD_PIXEL_SET	1
#define	GLCD_PIXEL_XOR	2


class GlcdPlus : public Print {
public:
    GlcdPlus() ;

    void clear(uint8_t cs) ;
    void pset(uint8_t, uint8_t, uint8_t) ;
    void drawLine(uint8_t, uint8_t, uint8_t, uint8_t, uint8_t) ;
    void drawRectangle(uint8_t, uint8_t, uint8_t, uint8_t, uint8_t) ;

    void backLight(uint8_t sw) ;

    void setCursor(uint8_t, uint8_t); 
    void setScroll(uint8_t top, uint8_t bottom) ;
    virtual void write(uint8_t);

    uint8_t sw1(void);
    uint8_t sw2(void);
    uint8_t sw3(void);
    uint8_t swAll(void);
    /*
    void home();

    */
private:
    SpiGpio gpio ;
    uint8_t pinE ;
    uint8_t _line, _col ;
    uint8_t __scrollTop ;
    uint8_t __scrollBottom ;

    uint8_t swBackLight ;
    uint8_t ioOut ;
    uint8_t ctrl ;

    void scroll(uint8_t top, uint8_t bottom) ;

    uint8_t dataGet(uint8_t bank) ;
    void dataSet(uint8_t bank, uint8_t data) ;
    void dataPut(uint8_t bank) ;

    uint8_t dataRead(uint8_t bank) ;
    void dataWrite(uint8_t bank, uint8_t data) ;
    uint8_t statusRead(uint8_t bank) ;
    void cmdWrite(uint8_t bank, uint8_t data) ;
};

#endif
