#include <GlcdPlus.h>
#include <SD.h>

File myFile;
GlcdPlus glcd ;

void
setup()
{
  glcd.backLight(1) ;

  glcd.clear(GLCD_SELECT_ALL) ;
  
  glcd.println("MicroFan GLCD-PLUS") ;
  glcd.println("Arduino Mini Shield") ;
  glcd.println("GLCD 128x64, MicroSD") ;
  glcd.println("") ;

  delay(5000) ;
  
  glcd.print("Initializing SD card...");

  if (!SD.begin(10)) {
    glcd.println(" failed!");
    return;
  }
  glcd.println(" done.");

  delay(3000) ;
  
  if (SD.exists("glcd.txt")) {
    glcd.println("glcd.txt exists.");
  } else {
    glcd.println("glcd.txt doesn't exist.");
  }

  delay(3000) ;
  
  // open a new file and immediately close it:
  glcd.println("Creating glcd.txt...");
  myFile = SD.open("glcd.txt", FILE_WRITE);
  myFile.close();

  // Check to see if the file exists: 
  if (SD.exists("glcd.txt")) {
    glcd.println("glcd.txt exists.");
  } else {
    glcd.println("glcd.txt doesn't exist.");  
  }

  delay(3000) ;

  // delete the file:
  glcd.println("Removing glcd.txt...");
  SD.remove("glcd.txt");

  if (SD.exists("glcd.txt")){ 
    glcd.print("glcd.txt exists.");
  } else {
    glcd.print("glcd.txt doesn't exist.");  
  }
}

void loop()
{
  // nothing happens after setup finishes.
}

